<?php

namespace FiloBlu\Newsletter\Model;

class SubscriberInfo extends \Magento\Framework\Model\AbstractModel {

    public function __construct(
    \Magento\Framework\Model\Context $context, \Magento\Framework\Registry $registry, \Magento\Framework\Stdlib\DateTime\DateTime $date, \Magento\Framework\Model\ResourceModel\AbstractResource $resource = null, \Magento\Framework\Data\Collection\AbstractDb $resourceCollection = null, array $data = []
    ) {
        $this->date = $date;

        parent::__construct($context, $registry, $resource, $resourceCollection);
    }

    /**
     * Initialize resource model
     *
     * @return void
     */
    protected function _construct() {
        $this->_init('FiloBlu\Newsletter\Model\ResourceModel\SubscriberInfo');
    }

    /**
     * Processing object before save data
     *
     * @return $this
     */
    public function beforeSave() {
        
        $currentDate = $this->date->gmtDate();
        if (!$this->getCreatedAt()) {
            $this->setCreatedAt($currentDate);
        }
        $this->setUpdatedAt($currentDate);
        
        parent::beforeSave();
    }

}
